
//31-12-2018
// rajout TimeNow en sec

//04-11/2018
// corectif ordre data HH MM Wday
// 15/10/2018   version speciale pour appli Appinventor 2  et format Date Time
// modif MAJ RTC pour s'adapter  Clock2 Parameters qui n'inclue pas le WeekDay
// WeekDay repouss en fin de cde
// reste compatible avec BlueTooth-Electronic.APK

 // 04-09-2018
 // 12-06-2018 rajout option Visu ou non sur Display (updated) Time
 // 28-05-2018
// suite probleme relecture jS > 6 => plantage 
// 15-05-2018

//RTC DS3231
  
  // rev 10-05-2017
 // Horloge_18F26K22_RTC_DS3231_60leds_180509.hex
 // modif : lecture de tous les registres RTC en 1 seule fois
 //rev 01-05-2018
 // separtation REFRESH & DISPLAY
 //rev 05-11-2017
 // simplification  affichage Time et Date , si on a pas besoin de faire du traitement sur date et time
 //  void BCD_To_Ascii(unsigned char cc,unsigned char *pp);
 //rev 30-09-2017
 
#include "Tiny_RTC_DS3231_for_AI2_2019.h"


void write_DS3231(unsigned short address,unsigned short w_data)  // I2C WRITE
 {
  I2C1_Start();
  I2C1_Wr(DS3231_ADDR);
  I2C1_Wr(address);
  I2C1_Wr(w_data);
  I2C1_Stop();
 }
 
unsigned short read_DS3231(unsigned short address)      // I2C read subroutine
{unsigned  short  clock_data  ;
  I2C1_Start();
  I2C1_Wr(DS3231_ADDR);
  I2C1_Wr(address); 
  I2C1_Repeated_Start();
  I2C1_Wr(DS3231_ADDR+1);
  clock_data=I2C1_Rd(0);
  I2C1_Stop();
  return(clock_data);
 }
 
void read_all_DS3231(void)      // I2C read subroutine
{
  I2C1_Start();
  I2C1_Wr(DS3231_ADDR);
  I2C1_Wr(0); // // start from word at address (REG0)
  I2C1_Repeated_Start();
  I2C1_Wr(DS3231_ADDR+1);
  second=I2C1_Rd(1);
   minute=I2C1_Rd(1);
    heure=I2C1_Rd(1);
     jS=I2C1_Rd(1);
          if (jS>6) jS=0;
      jour=I2C1_Rd(1);
       mois=I2C1_Rd(1);
        Annee=I2C1_Rd(0);
  I2C1_Stop();
        Hour= Bcd2Dec16(heure);
      Mn=Bcd2Dec16(minute);
      Sec=Bcd2Dec16(second);
 }

 void BCD_To_Ascii(unsigned char cc,unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }

void Display_Date_Time(char Visu)
{   unsigned char cx,mx,hx;
    //read_all_DS3231();
  I2C1_Start();
  I2C1_Wr(DS3231_ADDR);
  I2C1_Wr(0); // // start from word at address (REG0)
  I2C1_Repeated_Start();
  I2C1_Wr(DS3231_ADDR+1);
  second=I2C1_Rd(1);
   minute=I2C1_Rd(1);
    heure=I2C1_Rd(1);
     jS=I2C1_Rd(1);
          if (jS>6) jS=0;
      jour=I2C1_Rd(1);
       mois=I2C1_Rd(1);
        Annee=I2C1_Rd(0);
      I2C1_Stop();
     BCD_To_Ascii(heure,time) ;   time[2]=':';
     BCD_To_Ascii(minute,time+3 );  time[5]=':';
     BCD_To_Ascii(second,time+6);   time[8]=0;
     BCD_To_Ascii(jour,date); date[2]='-';
     BCD_To_Ascii(mois,date+3); date[5]='-';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
   if( Visu==1)
   {
      UART1_Write_Text(date);
    UART1_Write_CText(Blancs);
    UART1_Write_Text(time);
    UART1_Write_CText(Blancs);
     }
   if( Visu==2)
   {
      UART2_Write_Text(date);
    UART2_Write_CText(Blancs);
    UART2_Write_Text(time);
    UART2_Write_CText(Blancs);
     }
   // 28-12-2018
      Hour= Bcd2Dec16(heure);
      Mn=Bcd2Dec16(minute);
      Sec=Bcd2Dec16(second);
      TimeNow=(long)Hour * 3600 + (long) Mn *60 + second;
  }
  
  void Refresh_Date_Time(void)
{   // GIE_bit=0;
     second=read_DS3231(0);
     minute=read_DS3231(1);
     heure =read_DS3231(2);
     jS=read_DS3231(3);
     if (jS>6) jS=0;
     jour=read_DS3231(4);
     mois=read_DS3231(5);
     Annee=read_DS3231(6);
    // GIE_bit=1;
  }
  
void MAJ_RTC()
{ int m,i,j,k;
  m=2; // passe par dessus "U;"
  // U;24;08;17;17;36;02#
  CRLF1();
  j=0;
  //Status=0;
  RC1IE_bit = 0;
  *(Buffer1+Index1)=0;
  
   if ((Index1<22)&&(Index1>19))
    {
      // for debugging
      // UART1_Write_CText(" Index1 = ");
      // WordToStr(Index1,CRam1);
       // UART1_Write_Text(CRam1);
      //CRLF1();
        for (i=2;i<Index1;i++)
        {
          if(Buffer1[i]==';')
              {
                Buffer1[i]=0;
                DateTime[j]=atoi(Buffer1+m);
             //  UART1_Write_Text(Buffer1+m);CRLF1();
               j++;
               m=i+1;   // m=i+1;
              }
       }// for i
       // ne pas oublier de remettre en ordre pour la RTC!
       k=DateTime[3];
       DateTime[3]=DateTime[5];
       DateTime[5]=DateTime[4];
        DateTime[4]=k ;
        jour=DateTime[0];
        mois=DateTime[1];
        Annee=DateTime[2];
        jS=DateTime[3]; // jour de la semaine
       // WordToStr(jS,CRam1);
       // UART1_Write(9);
      // UART1_Write_Text(CRam1);CRLF1();
       //  UART1_Write_CText(JourSemaine[jS]);CRLF1();
        if (jS>6)
        {
             jS=0;  // dimanche par defaut !
              UART1_Write_CText("\r\nErreur sur Jour Semaine jS. OK\r\n");
        }
        heure=DateTime[4];
        minute=DateTime[5];
        write_DS3231(0,0x00); //Reset second to 0 sec. and stop Oscillator
        write_DS3231(1,Dec2Bcd(minute)); //write min
        write_DS3231(2,Dec2Bcd(heure)); //write hour
        write_DS3231(3,Dec2Bcd(jS)); //write day of week
        write_DS3231(4,Dec2Bcd(jour)); // write date
        write_DS3231(5,Dec2Bcd(mois)); // write month
        write_DS3231(6,Dec2Bcd(Annee)); // write year 2014

      write_DS3231(7,0x10); // Sortie SQW  1Hz
       //  write_DS3231(7,0x11); // Sortie SQW  4096 Hz
      //  write_DS3231(7,0x12); // Sortie SQW  8192 Hz
       // write_DS3231(7,0x13); // Sortie SQW  32768 Hz
      UART1_Write_CText("Ecriture dans DS3231... OK\r\n");
      CRLF1();
    }
    else
    {
    UART1_Write_CText("\r\n Rappel format de cde : \"U;JJ;MM;AA;HH;MM;WD;#\" \r\n");
    UART1_Write_CText(" U:24;08;17;18;36;04  pour 24 Aout 2017  18H36 04=Jeudi\r\n\r\n");
    }
 }